/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... konstruktor a destruktor
*/
#include<iostream>
#include<string>

using namespace std;

struct Zamestnanec
{
	string jmeno;
	string prijmeni;
	unsigned int plat;

	string jmenoAPrijmeni()
	{
		// plat = 1000;
		// return jmeno + " " + prijmeni;
		return this->jmeno + " " + this->prijmeni;
	}

	void vypis()
	{
		cout << "metoda: ";
		//cout << jmenoAPrijmeni() << " " << plat << endl;
		cout << this->jmenoAPrijmeni() << " " << this->plat << endl;
		//cout << jmeno << " " << prijmeni << " " << plat << endl;
	}

};

void vypis(const Zamestnanec &z)
{
	cout << "funkce: ";
	cout << z.jmeno << " " << z.prijmeni << " " << z.plat << endl;
}

class Zamestnanec1
{
//private:
	string jmeno = "x";
	string prijmeni="y";
	unsigned int plat=10000;
	const int ID;
	string jmenoAPrijmeni() const
	{
		// plat = 1000;
		// return jmeno + " " + prijmeni;
		return this->jmeno + " " + this->prijmeni;
	}
public:
	/*
	Zamestnanec1(const string &jmeno, const string &prijmeni="", unsigned int plat=1000)
	{
		cout << "konstruktor se tremi parametry" << endl;
		this->jmeno = jmeno;
		this->prijmeni = prijmeni;
		this->plat = plat;
	}*/
	Zamestnanec1(const string &_jmeno, const string &_prijmeni = "", unsigned int plat = 1000, int _ID=1) : ID(_ID), jmeno(_jmeno), prijmeni(_prijmeni)
	{
		cout << "konstruktor se tremi parametry" << endl;
		this->plat = plat;
	}

	Zamestnanec1() : ID(1)
	{
		cout << "konstruktor bez parametru" << endl;
		jmeno = "neznamy";
		prijmeni = "zamestnanec";
		plat = 0;

	}
	void nastavJmeno(const string& _jmeno) // setName
	{
		jmeno = _jmeno;
	}
	void nastavPrijmeni(const string& prijmeni)
	{
		this->prijmeni = prijmeni;
	}
	void nastavPlat(unsigned int plat)
	{
		if (plat < 10000 || plat > 50000)
			//return;
			this->plat = 10000;
		else
			this->plat = plat;
	}
	string vratJmeno() const // getName
	{
		return jmeno;
	}
	string vratPrijmeni() const // getName
	{
		return prijmeni;
	}

	unsigned int vratPlat() const // getName
	{
		return plat;
	}

	void vypis() const
	{
		cout << "metoda: ";
		//cout << jmenoAPrijmeni() << " " << plat << endl;
		cout << this->jmenoAPrijmeni() << " " << this->plat << endl;
		//cout << jmeno << " " << prijmeni << " " << plat << endl;
	}
	friend void vypis(const Zamestnanec1 &z);
	friend float premie(const Zamestnanec1 &z)
	{
		return z.plat *0.1;
	}
	friend class Zamestnanec2;

};

void vypis(const Zamestnanec1 &z)
{
	cout << "funkce: ";
	cout << z.jmenoAPrijmeni() << " " << z.plat << endl;
}


class Vektor
{
	double *a;
	const int n;
public:
	Vektor(int _n) : n(_n)
	{
		cout << "konstruktor" << endl;
		a = new double[n];
		for (int i = 0; i < n; i++)
			a[i] = 0;
	}
	void vypis()
	{
		for (int i = 0; i < n; i++)
			cout << a[i] << " ";
		cout << endl;
	}
	~Vektor()
	{
		cout << "destruktor" << endl;
		delete[] a;
	}
};


int main()
{
	{
		/*const Zamestnanec1 a;
		a.vypis();
		vypis(a);
		cout << premie(a) << endl;
		*/
		Zamestnanec1 vera, honza("Honza", "Novak", 80000);
		honza.vypis();
		vera.vypis();

		Zamestnanec1 *eva = new Zamestnanec1;
		eva->vypis();
		delete eva;

		eva = new Zamestnanec1();
		eva->vypis();
		delete eva;

		eva = new Zamestnanec1("Eva", "Nova", 3000);
		eva->vypis();
		delete eva;

		
		Zamestnanec* u = new Zamestnanec;
		u->jmeno = "Jana";
		u->prijmeni = "Nova";
		u->plat = 10000;
		vypis(*u);
		u->vypis();

		delete u;
	}

	{
		Vektor a(4);
		a.vypis();
		Vektor *b = new Vektor(6);
		b->vypis();
		delete b;

	}
	return 0;
}